function Dfs74000_CalculoReceitaBrutaSimplesNacional_Controller(ScreenService, templateManager,General, Dfs74000_CalculoReceitaBrutaSimplesNacional_Service) {

    this.controlaCampoTabelaSimplesNacional = function(widget){
        widget.currentRow.NMSIMPLESNACIONAL='';
        widget.currentRow.CDSIMPLESNACIONAL='';

        if(widget.currentRow.CDEMPRESA){
            widget.getField('NMSIMPLESNACIONAL').readOnly= false;
        }else{
            widget.getField('NMSIMPLESNACIONAL').readOnly= true;
        }
    };

    this.recarregarWidgetsTipoOperacaoReceita = function(widget){
        var widgetTipoOperacao = widget.widgets[0].widgets;
        var widgetReceita = widget.widgets[1].widgets[0];
        widgetTipoOperacao[0].reload();
        widgetTipoOperacao[1].reload();
        widgetReceita.reload();
        this.controlaActionsWidgetReceitaBruta(widgetReceita);
        if(widget.currentRow.CDEMPRESA && widget.currentRow.CDSIMPLESNACIONAL){
            widgetTipoOperacao[0].getAction('adicionarRow').readOnly = false;
            widgetTipoOperacao[1].getAction('adicionarRow').readOnly = false;
        }else{
            widgetTipoOperacao[0].getAction('adicionarRow').readOnly = true;
            widgetTipoOperacao[1].getAction('adicionarRow').readOnly = true;
        }
    };

    this.controlaActionsWidgetReceitaBruta = function(widgetReceita){
        var widgetFiltro = widgetReceita.parent.parent;
        var tabbedReceita = widgetReceita.parent;
        //caso todos os campos do filtro estejam preenchidos habilita a action de adiconar
        if(widgetFiltro.currentRow.CDEMPRESA && widgetFiltro.currentRow.CDSIMPLESNACIONAL && tabbedReceita.currentRow.P_ANO){
            widgetReceita.getAction('adicionarRow').readOnly = false;
        }
        else{
            widgetReceita.getAction('adicionarRow').readOnly = true;
        }
    };

    this.editarCalculoReceita = function (widget) {
        General.edit(widget);
        widget.currentRow.VRSALDOCOMPOE_OLD = widget.currentRow.VRSALDOCOMPOE;
        widget.currentRow.VRSALDODEDUZ_OLD = widget.currentRow.VRSALDODEDUZ;
    };

    this.saveTipoOperacao = function (widget){
        if(widget.name=='widgetCompoeReceita'){
            widget.currentRow.IDTIPOOPERREC='C';
        }else if(widget.name=='widgetDeduzReceita'){
            widget.currentRow.IDTIPOOPERREC='D';
        }
        widget.currentRow.CDSIMPLESNACIONAL = widget.parent.parent.currentRow.CDSIMPLESNACIONAL;
        var filter = [
            {
                name: "CDTIPOOPER",
                operator: "=",
                value: widget.currentRow.CDTIPOOPER
            },
            {
                name: "CDSIMPLESNACIONAL",
                operator: "=",
                value: widget.currentRow.CDSIMPLESNACIONAL
            },
            {
                name: "IDENTRSAIDOP",
                operator: "=",
                value: widget.currentRow.IDENTRSAIDOP
            }
        ];
        General.callRestEngine("df#/crud/tpopersimplesnac", "FilterData", filter).then((success) => {
            General.saveCrud(widget);
        });
    };
    
    this.updateITipoOperac = function(widget) {
        ScreenService.confirmMessage(ScreenService.i18n('Excluir Registro?'), 'question', function (success) {
            widget.currentRow.IDTIPOOPERREC = 'I';
            General.saveCrud(widget).then(() => {
                ScreenService.goBack();
                widget.reload();
            });
        });
    };

    this.saveReceitaBruta = function (widget){
        if(widget.isValid()){
            this.calculaValor(widget);
            var tabbedReceita = widget.parent;
            var tabbedCalculo = widget.parent.parent;
            if(widget.currentRow.__is_new){
                widget.currentRow.IDINFMANUAL       = 'M';
                widget.currentRow.CDEMPRESA         = tabbedCalculo.currentRow.CDEMPRESA;
                widget.currentRow.DTREFRECEITABR    = '01/'+widget.currentRow.MES+'/'+tabbedReceita.currentRow.P_ANO;
                widget.currentRow.CDSIMPLESNACIONAL = tabbedCalculo.currentRow.CDSIMPLESNACIONAL;
            }
            else{
                Dfs74000_CalculoReceitaBrutaSimplesNacional_Service.verificaValorAlterado(widget.currentRow);
            }
            Dfs74000_CalculoReceitaBrutaSimplesNacional_Service.validacoesSave(widget.currentRow).then(
                function(success) {
                    var mesAtual     = success.dataset.result.mesAtual;
                    var mesPosterior = success.dataset.result.mesPosterior;
                    var rows ={
                        'mesAtual':widget.currentRow,
                        'mesPosterior':mesPosterior
                    };
                    if(widget.currentRow.__is_new){
                        if(mesAtual.length == 0){
                            if(mesPosterior.length>0){
                                ScreenService.confirmMessage(ScreenService.i18n('Atenção! Ao confirmar esta operação o sistema irá desbloquear os meses posteriores ao mês corrente a ser excluído e irá recalcular a receita. Confirma a operação?'), 'question', function (success) {
                                    this.saveMes(widget,rows);

                                }.bind(this));
                            }else{
                                this.saveMes(widget,rows);
                            }
                        }else{
                            ScreenService.showMessage('Mês já cadastrado para o ano informado.');
                        }
                    }
                    else{
                        if(mesPosterior.length>0){
                            ScreenService.confirmMessage(ScreenService.i18n('Atenção! Ao confirmar esta operação o sistema irá desbloquear os meses posteriores ao mês corrente a ser excluído e irá recalcular a receita. Confirma a operação?'), 'question', function (success) {
                                this.saveMes(widget,rows);
                            }.bind(this));
                        }else{
                            this.saveMes(widget,rows);
                        }
                    }
                }.bind(this),
                function(callback){
                    if(callback.data){
                        ScreenService.showMessage(callback.data.error);
                    }
                }
            );

        }

    };

    this.saveMes = function(widget,rows){
        Dfs74000_CalculoReceitaBrutaSimplesNacional_Service.saveReceitaBruta(rows).then(
            function(Success) {
                widget.activate();
                if (widget.currentRow.__is_new) {
                    widget.list(true);
                    ScreenService.goBack();
                    widget.reload();
                } else {
                    widget.computeDescriptionOrder();
                    widget.view();
                }

                if(rows.mesPosterior.length>0){
                   widget.currentRow.MESCALCULADO = true;
                }

            }.bind(this),
            function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            }
        );
    };

    this.deletarReceitaBruta = function (widget){
        Dfs74000_CalculoReceitaBrutaSimplesNacional_Service.buscaMesPosterior(widget.currentRow).then(
            function(success) {
               var mesPosterior = success.dataset.result;
               var rows ={
                    'mesAtual':widget.currentRow,
                    'mesPosterior':mesPosterior
                };
                if(mesPosterior.length>0){
                    ScreenService.confirmMessage(ScreenService.i18n('Atenção! Ao confirmar esta operação o sistema irá desbloquear os meses posteriores ao mês corrente a ser excluído e irá recalcular a receita. Confirma a operação?'), 'question', function (success) {

                        Dfs74000_CalculoReceitaBrutaSimplesNacional_Service.deleteMesReceita(rows).then(
                            function(success) {
                                ScreenService.closeSwipe().then(function () {
                                    widget.activate();
                                });
                                widget.reload();
                            }.bind(this),
                            function(callback){
                                if(callback.data){
                                    ScreenService.showMessage(callback.data.error);
                                }
                            }
                        );

                    }.bind(this));
                }else{
                    General.deleteCrud(widget);
                }
            }.bind(this),
            function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            }
        );
    };

    this.calculaValor = function (widget){
        Dfs74000_CalculoReceitaBrutaSimplesNacional_Service.calculaValorTotalRceitaBruta(widget.currentRow);
    };

    this.aplicaFiltroAno = function(widget){
        var data = moment();
        widget.getField('P_ANO').value( data.format('YYYY') );
        widget.widgets[0].reload();
        this.controlaActionsWidgetReceitaBruta(widget.widgets[0]);
    };

    this.controlaActionsCalculoReceita = function(widget){
        if(!widget.currentRow.__is_new){
            var editar      = widget.getAction('editar');
            var excluir     = widget.getAction('DELETE');
            var calcular    = widget.getAction('calcularReceita');
            var bloquear    = widget.getAction('bloquearMes');
            var desbloquear = widget.getAction('desbloquearMes');
            switch(widget.currentRow.IDSTATUSMES){
                case'P':
                    editar.readOnly      = false;
                    excluir.readOnly     = false;
                    calcular.readOnly    = false;
                    bloquear.readOnly    = false;
                    desbloquear.readOnly = true;
                    break;
                case'C':
                    editar.readOnly      = false;
                    excluir.readOnly     = false;
                    calcular.readOnly    = false;
                    bloquear.readOnly    = false;
                    desbloquear.readOnly = true;
                    break;
                case'B':
                    editar.readOnly      = true;
                    excluir.readOnly     = true;
                    calcular.readOnly    = true;
                    bloquear.readOnly    = true;
                    desbloquear.readOnly = false;
                    break;
            }
        }
    };

    this.calcularReceitaBrutaMes = function(widget){
        Dfs74000_CalculoReceitaBrutaSimplesNacional_Service.buscaMesPosterior(widget.currentRow).then(
            function(Success) {
               var mesPosterior = Success.dataset.result;
               var rows ={
                    'mesAtual':widget.currentRow,
                    'mesPosterior':mesPosterior
                };
                if(mesPosterior.length>0){
                    ScreenService.confirmMessage(ScreenService.i18n('Atenção! Ao confirmar esta operação o sistema irá desbloquear os meses posteriores ao mês corrente e irá recalcular a receita. Confirma a operação?'), 'question', function (success) {

                        Dfs74000_CalculoReceitaBrutaSimplesNacional_Service.calculaReceitaBrutaMes(rows).then(
                            function(Success) {
                                widget.currentRow.IDINFMANUAL   = Success.dataset.receitaBruta.idinfmanual;
                                widget.currentRow.IDSTATUSMES   = Success.dataset.receitaBruta.idstatusmes;
                                widget.currentRow.VRSALDONEGMES = Success.dataset.receitaBruta.saldoNegativo;
                                widget.currentRow.VRSALDOCOMPOE = Success.dataset.receitaBruta.valorCompoem;
                                widget.currentRow.VRSALDODEDUZ  = Success.dataset.receitaBruta.valorDeduz;
                                widget.currentRow.VRRECEITABR   = Success.dataset.receitaBruta.valorTotal;
                                ScreenService.closePopup();
                                ScreenService.showMessage('Mês calculado com sucesso.');
                                this.controlaActionsCalculoReceita(widget);
                                widget.reload();
                                widget.currentRow.MESCALCULADO = true;
                            }.bind(this),
                            function(callback){
                                if(callback.data){
                                    ScreenService.showMessage(callback.data.error);
                                }
                            }
                        );
                    }.bind(this));
                }else{
                    Dfs74000_CalculoReceitaBrutaSimplesNacional_Service.calculaReceitaBrutaMes(rows).then(
                        function(Success) {
                                widget.currentRow.IDINFMANUAL   = Success.dataset.receitaBruta.idinfmanual;
                                widget.currentRow.IDSTATUSMES   = Success.dataset.receitaBruta.idstatusmes;
                                widget.currentRow.VRSALDONEGMES = Success.dataset.receitaBruta.saldoNegativo;
                                widget.currentRow.VRSALDOCOMPOE = Success.dataset.receitaBruta.valorCompoem;
                                widget.currentRow.VRSALDODEDUZ  = Success.dataset.receitaBruta.valorDeduz;
                                widget.currentRow.VRRECEITABR   = Success.dataset.receitaBruta.valorTotal;
                                ScreenService.closePopup();
                                ScreenService.showMessage('Mês calculado com sucesso.');
                                this.controlaActionsCalculoReceita(widget);
                                widget.reload();
                                widget.currentRow.MESCALCULADO = true;
                        }.bind(this),
                        function(callback){
                            if(callback.data){
                                ScreenService.showMessage(callback.data.error);
                            }
                        }
                    );
                }
            }.bind(this),
            function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            }
        );
    };

    this.desbloquearMesReceita = function (widget){
        widget.currentRow.IDSTATUSMES = 'P'; 
        General.saveCrud(widget).then(
            function(Success) {
                ScreenService.closePopup();
                this.controlaActionsCalculoReceita(widget);
                ScreenService.showMessage('Mês desbloqueado com sucesso.');
            }.bind(this),
            function(callback){
                widget.currentRow.IDSTATUSMES = 'B';
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            }
        );
    };

    this.bloquerMesReceita = function (widget){
        if(widget.currentRow.IDINFMANUAL == 'M'){
            Dfs74000_CalculoReceitaBrutaSimplesNacional_Service.buscaNotasFiscaisMes(widget.currentRow).then(
                function(Success) {
                    var notasFiscais = Success.dataset.notasFiscais;
                    if(notasFiscais.length >0){
                        ScreenService.confirmMessage(ScreenService.i18n('Atenção! Existem notas lançadas no sistema para este mês. Deseja recalcular?'), 'question',
                            function (Success) {
                                Dfs74000_CalculoReceitaBrutaSimplesNacional_Service.bloquerMesReceita(widget.currentRow).then(
                                    function(Success) {
                                        widget.currentRow.IDINFMANUAL   = Success.dataset.receitaBruta.idinfmanual;
                                        widget.currentRow.IDSTATUSMES   = Success.dataset.receitaBruta.idstatusmes;
                                        widget.currentRow.VRSALDONEGMES = Success.dataset.receitaBruta.saldoNegativo;
                                        widget.currentRow.VRSALDOCOMPOE = Success.dataset.receitaBruta.valorCompoem;
                                        widget.currentRow.VRSALDODEDUZ  = Success.dataset.receitaBruta.valorDeduz;
                                        widget.currentRow.VRRECEITABR   = Success.dataset.receitaBruta.valorTotal;
                                        ScreenService.closePopup();
                                        ScreenService.showMessage('Mês bloqueado com sucesso.');
                                        this.controlaActionsCalculoReceita(widget);
                                        widget.reload();
                                        widget.currentRow.MESCALCULADO = true;
                                    }.bind(this),
                                    function(callback){
                                        if(callback.data){
                                            ScreenService.showMessage(callback.data.error);
                                        }
                                    }
                                );
                            }.bind(this),
                            function (error) {
                                this.bloqueiaMes(widget);
                            }.bind(this)
                        );
                    }else{
                        this.bloqueiaMes(widget);
                    }
                }.bind(this),
                function(callback){
                    if(callback.data){
                        ScreenService.showMessage(callback.data.error);
                    }
                }
            );
        }else if(widget.currentRow.IDINFMANUAL == 'C'){
           this.bloqueiaMes(widget);
        }
    };

    this.actionVoltar = function (widget){
        ScreenService.goBack();
        if(widget.currentRow.MESCALCULADO){
            widget.reload();
            widget.currentRow.MESCALCULADO = false;
        }
    };

    this.bloqueiaMes = function (widget){
        var status = widget.currentRow.IDSTATUSMES;
        widget.currentRow.IDSTATUSMES = 'B';
        General.saveCrud(widget).then(
            function(Success) {
                ScreenService.closePopup();
                ScreenService.showMessage('Mês bloqueado com sucesso.');
                this.controlaActionsCalculoReceita(widget);
            }.bind(this),
            function(callback){
                widget.currentRow.IDSTATUSMES = status;
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            }
        );
    };

}
Configuration(function (ContextRegister) {
    ContextRegister.register("Dfs74000_CalculoReceitaBrutaSimplesNacional_Controller", Dfs74000_CalculoReceitaBrutaSimplesNacional_Controller);
});
